#ifndef SCREEN_DRIVER_H
#define SCREEN_DRIVER_H

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

enum vga_color {
	VGA_COLOR_BLACK = 0,
	VGA_COLOR_BLUE = 1,
	VGA_COLOR_GREEN = 2,
	VGA_COLOR_CYAN = 3,
	VGA_COLOR_RED = 4,
	VGA_COLOR_MAGENTA = 5,
	VGA_COLOR_BROWN = 6,
	VGA_COLOR_LIGHT_GREY = 7,
	VGA_COLOR_DARK_GREY = 8,
	VGA_COLOR_LIGHT_BLUE = 9,
	VGA_COLOR_LIGHT_GREEN = 10,
	VGA_COLOR_LIGHT_CYAN = 11,
	VGA_COLOR_LIGHT_RED = 12,
	VGA_COLOR_LIGHT_MAGENTA = 13,
	VGA_COLOR_LIGHT_BROWN = 14,
	VGA_COLOR_WHITE = 15,
};

uint8_t cursorX;
uint8_t cursorY;
int shiftKey, capsLock, altKey, ctrlKey, cmdKey;
 
static inline uint8_t vgaEntryColor(enum vga_color fg, enum vga_color bg);
 
static inline uint16_t vgaEntry(unsigned char uc, uint8_t color);
 
static const size_t VGA_WIDTH = 80;
static const size_t VGA_HEIGHT = 25;
 
size_t TRow;
size_t TColumn;
uint8_t TColor;
uint16_t* TBuffer;
 
void monInit(void);
 
void monSetColor(uint8_t color);
 
void monPutEntryAt(char c, uint8_t color, size_t x, size_t y);
 
void monPutchar(char c);
 
void monWrite(const char* data, size_t size);
 
void monWString(const char* data);

void monPut(char c);

void monWDec(uint32_t n);

void monWHex(uint32_t n);

#endif // SCREEN_DRIVER_H